/****************************************************************
Copyright (c) 1998 Sandro Sigala <ssigala@globalnet.it>.
All rights reserved.

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name of the author not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

The author disclaim all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall the author be liable for any
special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
****************************************************************/

#ifndef MAP_H
#define MAP_H

#include <qlist.h>
#include <qstring.h>

#include "kreptoned.h"

struct Transporter {
	int orig_x, orig_y;
	int dest_x, dest_y;

	Transporter(int ox, int oy, int dx, int dy)
		: orig_x(ox), orig_y(oy),
		  dest_x(dx), dest_y(dy) {}
};

class Map {
public:
	int width, height;
	QString password;
	QList<Transporter> transporters;
	int time_limit;

	Map();
	~Map();

	Sprite& xy(int x, int y) {
		return *(data + x + y*width);
	}

	void newMap(int xwidth, int xheight);
	void load(const QString& filename);
	void save(const QString& filename);

private:
	Sprite *data;
	void addTransporter(int ox, int oy, int dx, int dy);
	Transporter *findTransporter(int x, int y);
	void deleteTransporters();
};

#endif // !MAP_H
